--
-- Licensed to the Apache Software Foundation (ASF) under one
-- or more contributor license agreements.  See the NOTICE file
-- distributed with this work for additional information
-- regarding copyright ownership.  The ASF licenses this file
-- to you under the Apache License, Version 2.0 (the
-- "License"); you may not use this file except in compliance
-- with the License.  You may obtain a copy of the License at
--
--    http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing,
-- software distributed under the License is distributed on an
-- "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
-- KIND, either express or implied.  See the License for the
-- specific language governing permissions and limitations
-- under the License.
--
 
create table ODE_SCHEMA_VERSION (VERSION integer);
insert into ODE_SCHEMA_VERSION values (6);
-- Apache ODE - SimpleScheduler Database Schema
-- 
-- Apache Derby scripts by Maciej Szefler.
-- 
-- 

CREATE TABLE ode_job (
  jobid CHAR(64)  NOT NULL DEFAULT '',
  ts BIGINT  NOT NULL DEFAULT 0,
  nodeid char(64),
  scheduled int  NOT NULL DEFAULT 0,
  transacted int  NOT NULL DEFAULT 0,

  instanceId BIGINT,
  mexId varchar(255),
  processId varchar(255),
  type varchar(255),
  channel varchar(255),
  correlatorId varchar(255),
  correlationKeySet varchar(255),
  retryCount int,
  inMem int,
  detailsExt blob(4096),

  PRIMARY KEY(jobid));

CREATE INDEX IDX_ODE_JOB_TS ON ode_job(ts);
CREATE INDEX IDX_ODE_JOB_NODEID ON ode_job(nodeid);


CREATE TABLE BPEL_ACTIVITY_RECOVERY -- ActivityRecoveryDAOImpl
    (ID BIGINT NOT NULL, ACTIONS VARCHAR(255), ACTIVITY_ID BIGINT, CHANNEL VARCHAR(255), DATE_TIME TIMESTAMP, DETAILS CLOB, INSTANCE_ID BIGINT, REASON VARCHAR(255), RETRIES INTEGER, PRIMARY KEY (ID));
CREATE TABLE BPEL_CORRELATION_SET -- CorrelationSetDAOImpl
    (CORRELATION_SET_ID BIGINT NOT NULL, CORRELATION_KEY VARCHAR(255), NAME VARCHAR(255), SCOPE_ID BIGINT, PRIMARY KEY (CORRELATION_SET_ID));
CREATE TABLE BPEL_CORRELATOR -- CorrelatorDAOImpl
    (CORRELATOR_ID BIGINT NOT NULL, CORRELATOR_KEY VARCHAR(255), PROC_ID BIGINT, PRIMARY KEY (CORRELATOR_ID));
CREATE TABLE BPEL_CORSET_PROP -- CorrSetProperty
    (ID BIGINT NOT NULL, CORRSET_ID BIGINT, PROP_KEY VARCHAR(255), PROP_VALUE VARCHAR(255), PRIMARY KEY (ID));
CREATE TABLE BPEL_EVENT -- EventDAOImpl
    (EVENT_ID BIGINT NOT NULL, DETAIL VARCHAR(255), DATA BLOB, SCOPE_ID BIGINT, TSTAMP TIMESTAMP, TYPE VARCHAR(255), INSTANCE_ID BIGINT, PROCESS_ID BIGINT, PRIMARY KEY (EVENT_ID));
CREATE TABLE BPEL_FAULT -- FaultDAOImpl
    (FAULT_ID BIGINT NOT NULL, ACTIVITY_ID INTEGER, DATA CLOB, MESSAGE VARCHAR(4000), LINE_NUMBER INTEGER, NAME VARCHAR(255), PRIMARY KEY (FAULT_ID));
CREATE TABLE BPEL_MESSAGE -- MessageDAOImpl
    (MESSAGE_ID BIGINT NOT NULL, DATA CLOB, HEADER CLOB, TYPE VARCHAR(255), MESSAGE_EXCHANGE_ID VARCHAR(255), PRIMARY KEY (MESSAGE_ID));
CREATE TABLE BPEL_MESSAGE_EXCHANGE -- MessageExchangeDAOImpl
    (MESSAGE_EXCHANGE_ID VARCHAR(255) NOT NULL, CALLEE VARCHAR(255), CHANNEL VARCHAR(255), CORRELATION_ID VARCHAR(255), CORRELATION_KEYS VARCHAR(255), CORRELATION_STATUS VARCHAR(255), CREATE_TIME TIMESTAMP, DIRECTION INTEGER, EPR CLOB, FAULT VARCHAR(255), FAULT_EXPLANATION VARCHAR(255), OPERATION VARCHAR(255), PARTNER_LINK_MODEL_ID INTEGER, PATTERN VARCHAR(255), PIPED_ID VARCHAR(255), PORT_TYPE VARCHAR(255), PROPAGATE_TRANS SMALLINT, STATUS VARCHAR(255), SUBSCRIBER_COUNT INTEGER, CORR_ID BIGINT, PARTNER_LINK_ID BIGINT, PROCESS_ID BIGINT, PROCESS_INSTANCE_ID BIGINT, REQUEST_MESSAGE_ID BIGINT, RESPONSE_MESSAGE_ID BIGINT, PRIMARY KEY (MESSAGE_EXCHANGE_ID));
CREATE TABLE BPEL_MESSAGE_ROUTE -- MessageRouteDAOImpl
    (MESSAGE_ROUTE_ID BIGINT NOT NULL, CORRELATION_KEY VARCHAR(255), GROUP_ID VARCHAR(255), ROUTE_INDEX INTEGER, PROCESS_INSTANCE_ID BIGINT, ROUTE_POLICY VARCHAR(16), CORR_ID BIGINT, PRIMARY KEY (MESSAGE_ROUTE_ID));
CREATE TABLE BPEL_MEX_PROP -- MexProperty
    (ID BIGINT NOT NULL, MEX_ID VARCHAR(255), PROP_KEY VARCHAR(255), PROP_VALUE VARCHAR(2000), PRIMARY KEY (ID));
CREATE TABLE BPEL_PARTNER_LINK -- PartnerLinkDAOImpl
    (PARTNER_LINK_ID BIGINT NOT NULL, MY_EPR CLOB, MY_ROLE_NAME VARCHAR(255), MY_ROLE_SERVICE_NAME VARCHAR(255), MY_SESSION_ID VARCHAR(255), PARTNER_EPR CLOB, PARTNER_LINK_MODEL_ID INTEGER, PARTNER_LINK_NAME VARCHAR(255), PARTNER_ROLE_NAME VARCHAR(255), PARTNER_SESSION_ID VARCHAR(255), SCOPE_ID BIGINT, PRIMARY KEY (PARTNER_LINK_ID));
CREATE TABLE BPEL_PROCESS -- ProcessDAOImpl
    (ID BIGINT NOT NULL, GUID VARCHAR(255), PROCESS_ID VARCHAR(255), PROCESS_TYPE VARCHAR(255), VERSION BIGINT, PRIMARY KEY (ID));
CREATE TABLE BPEL_PROCESS_INSTANCE -- ProcessInstanceDAOImpl
    (ID BIGINT NOT NULL, DATE_CREATED TIMESTAMP, EXECUTION_STATE BLOB, FAULT_ID BIGINT, LAST_ACTIVE_TIME TIMESTAMP, LAST_RECOVERY_DATE TIMESTAMP, PREVIOUS_STATE SMALLINT, SEQUENCE BIGINT, INSTANCE_STATE SMALLINT, INSTANTIATING_CORRELATOR_ID BIGINT, PROCESS_ID BIGINT, ROOT_SCOPE_ID BIGINT, PRIMARY KEY (ID));
CREATE TABLE BPEL_SCOPE -- ScopeDAOImpl
    (SCOPE_ID BIGINT NOT NULL, MODEL_ID INTEGER, SCOPE_NAME VARCHAR(255), SCOPE_STATE VARCHAR(255), PROCESS_INSTANCE_ID BIGINT, PARENT_SCOPE_ID BIGINT, PRIMARY KEY (SCOPE_ID));
CREATE TABLE BPEL_XML_DATA -- XmlDataDAOImpl
    (XML_DATA_ID BIGINT NOT NULL, DATA CLOB, IS_SIMPLE_TYPE SMALLINT, NAME VARCHAR(255), SCOPE_ID BIGINT, PRIMARY KEY (XML_DATA_ID));
CREATE TABLE BPEL_XML_DATA_PROP -- XmlDataProperty
    (ID BIGINT NOT NULL, XML_DATA_ID BIGINT, PROP_KEY VARCHAR(255), PROP_VALUE VARCHAR(255), PRIMARY KEY (ID));
CREATE TABLE OPENJPA_SEQUENCE_TABLE (ID SMALLINT NOT NULL, SEQUENCE_VALUE BIGINT, PRIMARY KEY (ID));
CREATE TABLE STORE_DU -- DeploymentUnitDaoImpl
    (NAME VARCHAR(255) NOT NULL, DEPLOYDT TIMESTAMP, DEPLOYER VARCHAR(255), DIR VARCHAR(255), PRIMARY KEY (NAME));
CREATE TABLE STORE_PROCESS -- ProcessConfDaoImpl
    (PID VARCHAR(255) NOT NULL, STATE VARCHAR(255), TYPE VARCHAR(255), VERSION BIGINT, DU VARCHAR(255), PRIMARY KEY (PID));
CREATE TABLE STORE_PROCESS_PROP -- ProcessConfPropertyDaoImpl
    (ID BIGINT NOT NULL, PROP_KEY VARCHAR(255), PROP_VAL VARCHAR(255), PRIMARY KEY (ID));
CREATE TABLE STORE_PROC_TO_PROP (PROCESSCONFDAOIMPL_PID VARCHAR(255), STORE_PROPERTY_ID BIGINT);
CREATE TABLE STORE_VERSIONS -- VersionTrackerDAOImpl
    (ID BIGINT NOT NULL, VERSION BIGINT, PRIMARY KEY (ID));
CREATE INDEX I_BPL_VRY_INSTANCE ON BPEL_ACTIVITY_RECOVERY (INSTANCE_ID);
CREATE INDEX I_BPL__ST_SCOPE ON BPEL_CORRELATION_SET (SCOPE_ID);
CREATE INDEX I_BPL_LTR_PROCESS ON BPEL_CORRELATOR (PROC_ID);
CREATE INDEX I_BPL_PRP_CORRSET ON BPEL_CORSET_PROP (CORRSET_ID);
CREATE INDEX I_BPL_VNT_INSTANCE ON BPEL_EVENT (INSTANCE_ID);
CREATE INDEX I_BPL_VNT_PROCESS ON BPEL_EVENT (PROCESS_ID);
CREATE INDEX I_BPL_SSG_MESSAGEEXCHANGE ON BPEL_MESSAGE (MESSAGE_EXCHANGE_ID);
CREATE INDEX I_BPL_HNG_CORRELATOR ON BPEL_MESSAGE_EXCHANGE (CORR_ID);
CREATE INDEX I_BPL_HNG_PARTNERLINK ON BPEL_MESSAGE_EXCHANGE (PARTNER_LINK_ID);
CREATE INDEX I_BPL_HNG_PROCESS ON BPEL_MESSAGE_EXCHANGE (PROCESS_ID);
CREATE INDEX I_BPL_HNG_PROCESSINST ON BPEL_MESSAGE_EXCHANGE (PROCESS_INSTANCE_ID);
CREATE INDEX I_BPL_HNG_REQUEST ON BPEL_MESSAGE_EXCHANGE (REQUEST_MESSAGE_ID);
CREATE INDEX I_BPL_HNG_RESPONSE ON BPEL_MESSAGE_EXCHANGE (RESPONSE_MESSAGE_ID);
CREATE INDEX I_BPL__RT_CORRELATOR ON BPEL_MESSAGE_ROUTE (CORR_ID);
CREATE INDEX I_BPL__RT_PROCESSINST ON BPEL_MESSAGE_ROUTE (PROCESS_INSTANCE_ID);
CREATE INDEX I_BPL_PRP_MEX ON BPEL_MEX_PROP (MEX_ID);
CREATE INDEX I_BPL_LNK_SCOPE ON BPEL_PARTNER_LINK (SCOPE_ID);
CREATE INDEX I_BPL_TNC_FAULT ON BPEL_PROCESS_INSTANCE (FAULT_ID);
CREATE INDEX I_BPL_TNC_INSTANTIATINGCORRELATOR ON BPEL_PROCESS_INSTANCE (INSTANTIATING_CORRELATOR_ID);
CREATE INDEX I_BPL_TNC_PROCESS ON BPEL_PROCESS_INSTANCE (PROCESS_ID);
CREATE INDEX I_BPL_TNC_ROOTSCOPE ON BPEL_PROCESS_INSTANCE (ROOT_SCOPE_ID);
CREATE INDEX I_BPL_SCP_PARENTSCOPE ON BPEL_SCOPE (PARENT_SCOPE_ID);
CREATE INDEX I_BPL_SCP_PROCESSINSTANCE ON BPEL_SCOPE (PROCESS_INSTANCE_ID);
CREATE INDEX I_BPL__DT_SCOPE ON BPEL_XML_DATA (SCOPE_ID);
CREATE INDEX I_BPL_PRP_XMLDATA ON BPEL_XML_DATA_PROP (XML_DATA_ID);
CREATE INDEX I_STR_CSS_DU ON STORE_PROCESS (DU);
CREATE INDEX I_STR_PRP_ELEMENT ON STORE_PROC_TO_PROP (STORE_PROPERTY_ID);
CREATE INDEX I_STR_PRP_PROCESSCONFDAOIMPL_PID ON STORE_PROC_TO_PROP (PROCESSCONFDAOIMPL_PID);
